Share via


Servers - Import Database

Imports a bacpac into a new database.

POST https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.Sql/servers/{serverName}/import?api-version=2025-01-01

URI Parameters

Name In Required Type Description
resourceGroupName
path True

string

minLength: 1
maxLength: 90

The name of the resource group. The name is case insensitive.

serverName
path True

string

The name of the server.

subscriptionId
path True

string (uuid)

The ID of the target subscription. The value must be an UUID.

api-version
query True

string

minLength: 1

The API version to use for this operation.

Request Body

Name Required Type Description
administratorLogin True

string

Administrator login name. If AuthenticationType is ManagedIdentity, this field should specify the Managed Identity's resource ID.

storageKey True

string

Storage key for the storage account. If StorageKeyType is ManagedIdentity, this field should specify the Managed Identity's resource ID.

storageKeyType True

StorageKeyType

Storage key type: StorageAccessKey, SharedAccessKey, or ManagedIdentity.

storageUri True

string

Storage Uri.

administratorLoginPassword

string (password)

Administrator login password. If AuthenticationType is ManagedIdentity, this field should not be specified.

authenticationType

string

Type of credentials provided for access to the target SQL server: SQL, ADPassword or ManagedIdentity.

databaseName

string

Name of the import database.

edition

string

Edition of the import database.

maxSizeBytes

string

Max size in bytes for the import database.

networkIsolation

NetworkIsolationSettings

Optional resource information to enable network isolation for request.

serviceObjectiveName

string

Service level objective name of the import database.

Responses

Name Type Description
200 OK

ImportExportOperationResult

Azure operation completed successfully.

202 Accepted

Resource operation accepted.

Headers

  • Location: string
  • Retry-After: integer
Other Status Codes

ErrorResponse

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

Imports to a new database, using Managed Identity for the SQL server and storage account.
Imports to a new database, using private link for the SQL server and storage account.
Imports to a new database.

Imports to a new database, using Managed Identity for the SQL server and storage account.

Sample request

POST https://management.azure.com/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/Default-SQL-SouthEastAsia/providers/Microsoft.Sql/servers/testsvr/import?api-version=2025-01-01

{
  "administratorLogin": "/subscriptions/00000000-1111-2222-3333-444444444444/resourcegroups/rgName/providers/Microsoft.ManagedIdentity/userAssignedIdentities/identityName",
  "authenticationType": "ManagedIdentity",
  "databaseName": "testdb",
  "storageKey": "/subscriptions/00000000-1111-2222-3333-444444444444/resourcegroups/rgName/providers/Microsoft.ManagedIdentity/userAssignedIdentities/identityName",
  "storageKeyType": "ManagedIdentity",
  "storageUri": "https://test.blob.core.windows.net/test.bacpac"
}

Sample response

{
  "name": "9d9a794a-5cec-4f23-af70-d29511b522a4",
  "type": "Microsoft.Sql/servers/databases/importExportOperationResults",
  "id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/Default-SQL-SouthEastAsia/providers/Microsoft.Sql/servers/testsvr/databases/testdb/importExportOperationResults/9d9a794a-5cec-4f23-af70-d29511b522a4",
  "properties": {
    "blobUri": "https://test.blob.core.windows.net/test.bacpac",
    "databaseName": "testdb",
    "lastModifiedTime": "2/2/2020 8:34:47 PM",
    "queuedTime": "2/2/2020 8:33:27 PM",
    "requestId": "9d9a794a-5cec-4f23-af70-d29511b522a4",
    "requestType": "Import",
    "serverName": "testsvr.database.windows.net",
    "status": "Completed"
  }
}
Location: https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/myResourceGroup/providers/Microsoft.Sql/locations/japaneast/importExportOperationResults/00000000-0000-0000-0000-000000000000?api-version=2022-08-01

Sample request

POST https://management.azure.com/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/Default-SQL-SouthEastAsia/providers/Microsoft.Sql/servers/testsvr/import?api-version=2025-01-01

{
  "administratorLogin": "login",
  "administratorLoginPassword": "password",
  "authenticationType": "Sql",
  "databaseName": "testdb",
  "networkIsolation": {
    "sqlServerResourceId": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/Default-SQL-SouthEastAsia/providers/Microsoft.Sql/servers/testsvr",
    "storageAccountResourceId": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/Default-SQL-SouthEastAsia/providers/Microsoft.Storage/storageAccounts/test-privatelink"
  },
  "storageKey": "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx==",
  "storageKeyType": "StorageAccessKey",
  "storageUri": "https://test.blob.core.windows.net/test.bacpac"
}

Sample response

{
  "name": "9d9a794a-5cec-4f23-af70-d29511b522a4",
  "type": "Microsoft.Sql/servers/databases/importExportOperationResults",
  "id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/Default-SQL-SouthEastAsia/providers/Microsoft.Sql/servers/testsvr/databases/testdb/importExportOperationResults/9d9a794a-5cec-4f23-af70-d29511b522a4",
  "properties": {
    "blobUri": "https://test.blob.core.windows.net/test.bacpac",
    "databaseName": "testdb",
    "lastModifiedTime": "2/2/2020 8:34:47 PM",
    "queuedTime": "2/2/2020 8:33:27 PM",
    "requestId": "9d9a794a-5cec-4f23-af70-d29511b522a4",
    "requestType": "Import",
    "serverName": "testsvr.database.windows.net",
    "status": "Completed"
  }
}
Location: https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/myResourceGroup/providers/Microsoft.Sql/locations/japaneast/importExportOperationResults/00000000-0000-0000-0000-000000000000?api-version=2022-08-01

Imports to a new database.

Sample request

POST https://management.azure.com/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/Default-SQL-SouthEastAsia/providers/Microsoft.Sql/servers/testsvr/import?api-version=2025-01-01

{
  "administratorLogin": "login",
  "administratorLoginPassword": "password",
  "authenticationType": "Sql",
  "databaseName": "testdb",
  "storageKey": "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx==",
  "storageKeyType": "StorageAccessKey",
  "storageUri": "https://test.blob.core.windows.net/test.bacpac"
}

Sample response

{
  "name": "9d9a794a-5cec-4f23-af70-d29511b522a4",
  "type": "Microsoft.Sql/servers/databases/importExportOperationResults",
  "id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/Default-SQL-SouthEastAsia/providers/Microsoft.Sql/servers/testsvr/databases/testdb/importExportOperationResults/9d9a794a-5cec-4f23-af70-d29511b522a4",
  "properties": {
    "blobUri": "https://test.blob.core.windows.net/test.bacpac",
    "databaseName": "testdb",
    "lastModifiedTime": "2/2/2020 8:34:47 PM",
    "queuedTime": "2/2/2020 8:33:27 PM",
    "requestId": "9d9a794a-5cec-4f23-af70-d29511b522a4",
    "requestType": "Import",
    "serverName": "testsvr.database.windows.net",
    "status": "Completed"
  }
}
Location: https://management.azure.com/subscriptions/00000000-0000-0000-0000-000000000000/resourceGroups/myResourceGroup/providers/Microsoft.Sql/locations/japaneast/importExportOperationResults/00000000-0000-0000-0000-000000000000?api-version=2022-08-01

Definitions

Name Description
createdByType

The type of identity that created the resource.

ErrorAdditionalInfo

The resource management error additional info.

ErrorDetail

The error detail.

ErrorResponse

Error response

ImportExportOperationResult

An ImportExport operation result resource.

ImportNewDatabaseDefinition

Contains the information necessary to perform import operation for new database.

NetworkIsolationSettings

Contains the ARM resources for which to create private endpoint connection.

PrivateEndpointConnectionRequestStatus

Contains the private endpoint connection requests status.

StorageKeyType

Storage key type: StorageAccessKey, SharedAccessKey or ManagedIdentity.

systemData

Metadata pertaining to creation and last modification of the resource.

createdByType

The type of identity that created the resource.

Value Description
User
Application
ManagedIdentity
Key

ErrorAdditionalInfo

The resource management error additional info.

Name Type Description
info

object

The additional info.

type

string

The additional info type.

ErrorDetail

The error detail.

Name Type Description
additionalInfo

ErrorAdditionalInfo[]

The error additional info.

code

string

The error code.

details

ErrorDetail[]

The error details.

message

string

The error message.

target

string

The error target.

ErrorResponse

Error response

Name Type Description
error

ErrorDetail

The error object.

ImportExportOperationResult

An ImportExport operation result resource.

Name Type Description
id

string (arm-id)

Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"

name

string

The name of the resource

properties.blobUri

string

Blob Uri.

properties.databaseName

string

Database name.

properties.errorMessage

string

Error message.

properties.lastModifiedTime

string

Last modified time.

properties.privateEndpointConnections

PrivateEndpointConnectionRequestStatus[]

Gets the status of private endpoints associated with this request.

properties.queuedTime

string

Queued time.

properties.requestId

string (uuid)

Request Id.

properties.requestType

string

Request type.

properties.serverName

string

Server name.

properties.status

string

Operation status.

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

ImportNewDatabaseDefinition

Contains the information necessary to perform import operation for new database.

Name Type Description
administratorLogin

string

Administrator login name. If AuthenticationType is ManagedIdentity, this field should specify the Managed Identity's resource ID.

administratorLoginPassword

string (password)

Administrator login password. If AuthenticationType is ManagedIdentity, this field should not be specified.

authenticationType

string

Type of credentials provided for access to the target SQL server: SQL, ADPassword or ManagedIdentity.

databaseName

string

Name of the import database.

edition

string

Edition of the import database.

maxSizeBytes

string

Max size in bytes for the import database.

networkIsolation

NetworkIsolationSettings

Optional resource information to enable network isolation for request.

serviceObjectiveName

string

Service level objective name of the import database.

storageKey

string

Storage key for the storage account. If StorageKeyType is ManagedIdentity, this field should specify the Managed Identity's resource ID.

storageKeyType

StorageKeyType

Storage key type: StorageAccessKey, SharedAccessKey, or ManagedIdentity.

storageUri

string

Storage Uri.

NetworkIsolationSettings

Contains the ARM resources for which to create private endpoint connection.

Name Type Description
sqlServerResourceId

string (arm-id)

The resource id for the SQL server which is the target of this request. If set, private endpoint connection will be created for the SQL server. Must match server which is target of the operation.

storageAccountResourceId

string (arm-id)

The resource id for the storage account used to store BACPAC file. If set, private endpoint connection will be created for the storage account. Must match storage account used for StorageUri parameter.

PrivateEndpointConnectionRequestStatus

Contains the private endpoint connection requests status.

Name Type Description
privateEndpointConnectionName

string

The connection name for the private endpoint.

privateLinkServiceId

string

Resource id for which the private endpoint is created.

status

string

Status of this private endpoint connection.

StorageKeyType

Storage key type: StorageAccessKey, SharedAccessKey or ManagedIdentity.

Value Description
SharedAccessKey

SharedAccessKey

StorageAccessKey

StorageAccessKey

ManagedIdentity

ManagedIdentity

systemData

Metadata pertaining to creation and last modification of the resource.

Name Type Description
createdAt

string (date-time)

The timestamp of resource creation (UTC).

createdBy

string

The identity that created the resource.

createdByType

createdByType

The type of identity that created the resource.

lastModifiedAt

string (date-time)

The timestamp of resource last modification (UTC)

lastModifiedBy

string

The identity that last modified the resource.

lastModifiedByType

createdByType

The type of identity that last modified the resource.